Subject: Re: Luca Deri's paper: Improving Passive Packet Capture: Beyond Device Polling

From: Ben Greear <[email-masked]>
Date: Tue, 06 Apr 2004 11:40:44 -0700

Jason Lunz wrote:
> [email-masked] said:
> 
>>In addition if you do care about performance, I believe you're willing
>>to turn off packet transmission and only do packet receive. 
> 
> 
> I don't understand what you mean by this. packet-mmap works perfectly
> well on an UP|PROMISC interface with no addresses bound to it. As long
> as no packets are injected through a packet socket, the tx path never
> gets involved.
> 
> 
>>IRQ: Linux has far too much latency, in particular at high speeds. I'm
>>not the right person who can say "this is the way to go", however I
>>believe that we need some sort of interrupt prioritization like RTIRQ
>>does.
> 
> 
> I don't think this is the problem, since small-packet performance is bad
> even with a fully-polling e1000 in NAPI mode. As Robert Olsson has
> demonstrated, a highly-loaded napi e1000 only generates a few hundred
> interrupts per second. So the vast majority of packets recieved are
> coming in without a hardware interrupt occurring at all.

If the polling is delayed, then you get plenty of latency.

With something like e1000, you can have up to 4096 rx buffers too,
which can also increase latency, but you do drop fewer packets.

Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com